/*
 * Licensed under the terms of the GNU GENERAL PUBLIC LICENSE version 2.
 * See file COPYING for details.
 */

#ifndef fam12h_h
#define fam12h_h

#include "../msr.h"

_RANGE(fam12h_LSMCAaddr,64,0);
_NAMES(fam12h_LSMCAaddr,"ADDR");
_RANGE(fam12h_LSMCAstatus,16,4,4,8,13,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(fam12h_LSMCAstatus,"ErrorCode","ErrorCodeExt",0,"SYND",0,"UECC","CECC","SYND",0,"PCC","ADDRV","MISCV","EN","UC","OVER","VAL");
_RANGE(fam12h_TSC,64,0);
_NAMES(fam12h_TSC,"TSC");
_RANGE(fam12h_APIC_BASE,8,1,2,1,28,24,0);
_NAMES(fam12h_APIC_BASE,0,"BSC",0,"ApicEn","ApicBar",0);
_RANGE(fam12h_EBL_CR_POWERON,16,2,46,0);
_NAMES(fam12h_EBL_CR_POWERON,0,"ClusterID",0);
_RANGE(fam12h_PATCH_LEVEL,32,32,0);
_NAMES(fam12h_PATCH_LEVEL,"PATCH_LEVEL",0);
_RANGE(fam12h_MPERF,64,0);
_NAMES(fam12h_MPERF,"MPERF");
_RANGE(fam12h_APERF,64,0);
_NAMES(fam12h_APERF,"APERF");
_RANGE(fam12h_MTRRcap,8,1,1,1,53,0);
_NAMES(fam12h_MTRRcap,"MtrrCapVCnt","MtrrCapFix",0,"MtrrCapWc",0);
_RANGE(fam12h_SYSENTER_CS,16,48,0);
_NAMES(fam12h_SYSENTER_CS,"SYSENTER_CS",0);
_RANGE(fam12h_SYSENTER_ESP,32,32,0);
_NAMES(fam12h_SYSENTER_ESP,"SYSENTER_ESP",0);
_RANGE(fam12h_SYSENTER_EIP,32,32,0);
_NAMES(fam12h_SYSENTER_EIP,"SYSENTER_EIP",0);
_RANGE(fam12h_MCG_CAP,8,1,55,0);
_NAMES(fam12h_MCG_CAP,"Count","MCG_CTL_P",0);
_RANGE(fam12h_MCG_STAT,1,1,1,61,0);
_NAMES(fam12h_MCG_STAT,"RIPV","EIPV","MCIP",0);
_RANGE(fam12h_MCG_CTL,1,1,1,1,1,1,58,0);
_NAMES(fam12h_MCG_CTL,"LS","IF","BU","FP","NB","FR",0);
_RANGE(fam12h_DBG_CTL_MSR,1,1,1,1,1,1,58,0);
_NAMES(fam12h_DBG_CTL_MSR,"LBR","BTF","PB0","PB1","PB2","PB3",0);
_RANGE(fam12h_BR_FROM,64,0);
_NAMES(fam12h_BR_FROM,"LastBranchFromIP");
_RANGE(fam12h_BR_TO,64,0);
_NAMES(fam12h_BR_TO,"LastBranchToIP");
_RANGE(fam12h_LastExceptionFromIP,64,0);
_NAMES(fam12h_LastExceptionFromIP,"LastIntFromIP");
_RANGE(fam12h_LastExceptionToIP,64,0);
_NAMES(fam12h_LastExceptionToIP,"LastIntToIP");
_RANGE(fam12h_MTRRphysBase0,3,9,28,24,0);
_NAMES(fam12h_MTRRphysBase0,"MemType",0,"PhyBase",0);
_RANGE(fam12h_MTRRphysMask0,11,1,28,24,0);
_NAMES(fam12h_MTRRphysMask0,0,"Valid","PhysMask",0);
_RANGE(fam12h_MTRRphysBase1,3,9,28,24,0);
_NAMES(fam12h_MTRRphysBase1,"MemType",0,"PhyBase",0);
_RANGE(fam12h_MTRRphysMask1,11,1,28,24,0);
_NAMES(fam12h_MTRRphysMask1,0,"Valid","PhysMask",0);
_RANGE(fam12h_MTRRphysBase2,3,9,28,24,0);
_NAMES(fam12h_MTRRphysBase2,"MemType",0,"PhyBase",0);
_RANGE(fam12h_MTRRphysMask2,11,1,28,24,0);
_NAMES(fam12h_MTRRphysMask2,0,"Valid","PhysMask",0);
_RANGE(fam12h_MTRRphysBase3,3,9,28,24,0);
_NAMES(fam12h_MTRRphysBase3,"MemType",0,"PhyBase",0);
_RANGE(fam12h_MTRRphysMask3,11,1,28,24,0);
_NAMES(fam12h_MTRRphysMask3,0,"Valid","PhysMask",0);
_RANGE(fam12h_MTRRphysBase4,3,9,28,24,0);
_NAMES(fam12h_MTRRphysBase4,"MemType",0,"PhyBase",0);
_RANGE(fam12h_MTRRphysMask4,11,1,28,24,0);
_NAMES(fam12h_MTRRphysMask4,0,"Valid","PhysMask",0);
_RANGE(fam12h_MTRRphysBase5,3,9,28,24,0);
_NAMES(fam12h_MTRRphysBase5,"MemType",0,"PhyBase",0);
_RANGE(fam12h_MTRRphysMask5,11,1,28,24,0);
_NAMES(fam12h_MTRRphysMask5,0,"Valid","PhysMask",0);
_RANGE(fam12h_MTRRphysBase6,3,9,28,24,0);
_NAMES(fam12h_MTRRphysBase6,"MemType",0,"PhyBase",0);
_RANGE(fam12h_MTRRphysMask6,11,1,28,24,0);
_NAMES(fam12h_MTRRphysMask6,0,"Valid","PhysMask",0);
_RANGE(fam12h_MTRRphysBase7,3,9,28,24,0);
_NAMES(fam12h_MTRRphysBase7,"MemType",0,"PhyBase",0);
_RANGE(fam12h_MTRRphysMask7,11,1,28,24,0);
_NAMES(fam12h_MTRRphysMask7,0,"Valid","PhysMask",0);
_RANGE(fam12h_MTRRfix64K_00000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam12h_MTRRfix64K_00000,"0xxxxMemType","0xxxxWrDram","0xxxxRdDram",0,"1xxxxMemType","1xxxxWrDram","1xxxxRdDram",0,"2xxxxMemType","2xxxxWrDram","2xxxxRdDram",0,"3xxxxMemType","3xxxxWrDram","3xxxxRdDram",0,"4xxxxMemType","4xxxxWrDram","4xxxxRdDram",0,"5xxxxMemType","5xxxxWrDram","5xxxxRdDram",0,"6xxxxMemType","6xxxxWrDram","6xxxxRdDram",0,"7xxxxMemType","7xxxxWrDram","7xxxxRdDram",0);
_RANGE(fam12h_MTRRfix16K_80000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam12h_MTRRfix16K_80000,"80xxxMemType","80xxxWrDram","80xxxRdDram",0,"84xxxMemType","84xxxWrDram","84xxxRdDram",0,"88xxxMemType","88xxxWrDram","88xxxRdDram",0,"8CxxxMemType","8CxxxWrDram","8CxxxRdDram",0,"90xxxMemType","90xxxWrDram","90xxxRdDram",0,"94xxxMemType","94xxxWrDram","94xxxRdDram",0,"98xxxMemType","98xxxWrDram","98xxxRdDram",0,"9CxxxMemType","9CxxxWrDram","9CxxxRdDram",0);
_RANGE(fam12h_MTRRfix16K_A0000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam12h_MTRRfix16K_A0000,"A0xxxMemType","A0xxxWrDram","A0xxxRdDram",0,"A4xxxMemType","A4xxxWrDram","A4xxxRdDram",0,"A8xxxMemType","A8xxxWrDram","A8xxxRdDram",0,"ACxxxMemType","ACxxxWrDram","ACxxxRdDram",0,"B0xxxMemType","B0xxxWrDram","B0xxxRdDram",0,"B4xxxMemType","B4xxxWrDram","B4xxxRdDram",0,"B8xxxMemType","B8xxxWrDram","B8xxxRdDram",0,"BCxxxMemType","BCxxxWrDram","BCxxxRdDram",0);
_RANGE(fam12h_MTRRfix4K_C0000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam12h_MTRRfix4K_C0000,"C0xxxMemType","C0xxxWrDram","C0xxxRdDram",0,"C1xxxMemType","C1xxxWrDram","C1xxxRdDram",0,"C2xxxMemType","C2xxxWrDram","C2xxxRdDram",0,"C3xxxMemType","C3xxxWrDram","C3xxxRdDram",0,"C4xxxMemType","C4xxxWrDram","C4xxxRdDram",0,"C5xxxMemType","C5xxxWrDram","C5xxxRdDram",0,"C6xxxMemType","C6xxxWrDram","C6xxxRdDram",0,"C7xxxMemType","C7xxxWrDram","C7xxxRdDram",0);
_RANGE(fam12h_MTRRfix4K_C8000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam12h_MTRRfix4K_C8000,"C8xxxMemType","C8xxxWrDram","C8xxxRdDram",0,"C9xxxMemType","C9xxxWrDram","C9xxxRdDram",0,"CAxxxMemType","CAxxxWrDram","CAxxxRdDram",0,"CBxxxMemType","CBxxxWrDram","CBxxxRdDram",0,"CCxxxMemType","CCxxxWrDram","CCxxxRdDram",0,"CDxxxMemType","CDxxxWrDram","CDxxxRdDram",0,"CExxxMemType","CExxxWrDram","CExxxRdDram",0,"CFxxxMemType","CFxxxWrDram","CFxxxRdDram",0);
_RANGE(fam12h_MTRRfix4K_D0000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam12h_MTRRfix4K_D0000,"D0xxxMemType","D0xxxWrDram","D0xxxRdDram",0,"D1xxxMemType","D1xxxWrDram","D1xxxRdDram",0,"D2xxxMemType","D2xxxWrDram","D2xxxRdDram",0,"D3xxxMemType","D3xxxWrDram","D3xxxRdDram",0,"D4xxxMemType","D4xxxWrDram","D4xxxRdDram",0,"D5xxxMemType","D5xxxWrDram","D5xxxRdDram",0,"D6xxxMemType","D6xxxWrDram","D6xxxRdDram",0,"D7xxxMemType","D7xxxWrDram","D7xxxRdDram",0);
_RANGE(fam12h_MTRRfix4K_D8000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam12h_MTRRfix4K_D8000,"D8xxxMemType","D8xxxWrDram","D8xxxRdDram",0,"D9xxxMemType","D9xxxWrDram","D9xxxRdDram",0,"DAxxxMemType","DAxxxWrDram","DAxxxRdDram",0,"DBxxxMemType","DBxxxWrDram","DBxxxRdDram",0,"DCxxxMemType","DCxxxWrDram","DCxxxRdDram",0,"DDxxxMemType","DDxxxWrDram","DDxxxRdDram",0,"DExxxMemType","DExxxWrDram","DExxxRdDram",0,"DFxxxMemType","DFxxxWrDram","DFxxxRdDram",0);
_RANGE(fam12h_MTRRfix4K_E0000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam12h_MTRRfix4K_E0000,"E0xxxMemType","E0xxxWrDram","E0xxxRdDram",0,"E1xxxMemType","E1xxxWrDram","E1xxxRdDram",0,"E2xxxMemType","E2xxxWrDram","E2xxxRdDram",0,"E3xxxMemType","E3xxxWrDram","E3xxxRdDram",0,"E4xxxMemType","E4xxxWrDram","E4xxxRdDram",0,"E5xxxMemType","E5xxxWrDram","E5xxxRdDram",0,"E6xxxMemType","E6xxxWrDram","E6xxxRdDram",0,"E7xxxMemType","E7xxxWrDram","E7xxxRdDram",0);
_RANGE(fam12h_MTRRfix4K_E8000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam12h_MTRRfix4K_E8000,"E8xxxMemType","E8xxxWrDram","E8xxxRdDram",0,"E9xxxMemType","E9xxxWrDram","E9xxxRdDram",0,"EAxxxMemType","EAxxxWrDram","EAxxxRdDram",0,"EBxxxMemType","EBxxxWrDram","EBxxxRdDram",0,"ECxxxMemType","ECxxxWrDram","ECxxxRdDram",0,"EDxxxMemType","EDxxxWrDram","EDxxxRdDram",0,"EExxxMemType","EExxxWrDram","EExxxRdDram",0,"EFxxxMemType","EFxxxWrDram","EFxxxRdDram",0);
_RANGE(fam12h_MTRRfix4K_F0000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam12h_MTRRfix4K_F0000,"F0xxxMemType","F0xxxWrDram","F0xxxRdDram",0,"F1xxxMemType","F1xxxWrDram","F1xxxRdDram",0,"F2xxxMemType","F2xxxWrDram","F2xxxRdDram",0,"F3xxxMemType","F3xxxWrDram","F3xxxRdDram",0,"F4xxxMemType","F4xxxWrDram","F4xxxRdDram",0,"F5xxxMemType","F5xxxWrDram","F5xxxRdDram",0,"F6xxxMemType","F6xxxWrDram","F6xxxRdDram",0,"F7xxxMemType","F7xxxWrDram","F7xxxRdDram",0);
_RANGE(fam12h_MTRRfix4K_F8000,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,3,1,1,3,0);
_NAMES(fam12h_MTRRfix4K_F8000,"F8xxxMemType","F8xxxWrDram","F8xxxRdDram",0,"F9xxxMemType","F9xxxWrDram","F9xxxRdDram",0,"FAxxxMemType","FAxxxWrDram","FAxxxRdDram",0,"FBxxxMemType","FBxxxWrDram","FBxxxRdDram",0,"FCxxxMemType","FCxxxWrDram","FCxxxRdDram",0,"FDxxxMemType","FDxxxWrDram","FDxxxRdDram",0,"FExxxMemType","FExxxWrDram","FExxxRdDram",0,"FFxxxMemType","FFxxxWrDram","FFxxxRdDram",0);
_RANGE(fam12h_PAT,3,5,3,5,3,5,3,5,3,5,3,5,3,5,3,5,0);
_NAMES(fam12h_PAT,"PA0MemType",0,"PA1MemType",0,"PA2MemType",0,"PA3MemType",0,"PA4MemType",0,"PA5MemType",0,"PA6MemType",0,"PA7MemType",0);
_RANGE(fam12h_MTRRdefType,8,2,1,1,52,0);
_NAMES(fam12h_MTRRdefType,"MemType",0,"MtrrDefTypeFixEn","MtrrDefTypeEn",0);
_RANGE(fam12h_MC0_CTL,1,1,1,1,1,1,1,57,0);
_NAMES(fam12h_MC0_CTL,"ECCI","ECCM","DECC","DMTP","DSTP","L1TP","L2TP",0);
_RANGE(fam12h_MC0_STATUS,16,4,4,8,13,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(fam12h_MC0_STATUS,"ErrorCode","ErrorCodeExt",0,"Syndrome",0,"UECC","CECC","Syndrome",0,"PCC","AddrV","MiscV","En","UC","OVER","VAL");
_RANGE(fam12h_MC0_ADDR,64,0);
_NAMES(fam12h_MC0_ADDR,"ADDR");
_RANGE(fam12h_MC0_MISC,64,0);
_NAMES(fam12h_MC0_MISC,0);
_RANGE(fam12h_MC1_CTL,1,1,1,1,1,1,1,2,1,54,0);
_NAMES(fam12h_MC1_CTL,"ECCI","ECCM","IDP","IMTP","ISTP","L1TP","L2TP",0,"RDDE",0);
_RANGE(fam12h_MC1_STATUS,16,4,4,8,13,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(fam12h_MC1_STATUS,"ErrorCode","ErrorCodeExt",0,"Syndrome",0,"UECC","CECC","Syndrome",0,"PCC","AddrV","MiscV","En","UC","OVER","VAL");
_RANGE(fam12h_MC1_ADDR,64,0);
_NAMES(fam12h_MC1_ADDR,"ADDR");
_RANGE(fam12h_MC1_MISC,64,0);
_NAMES(fam12h_MC1_MISC,0);
_RANGE(fam12h_MC2_CTL,1,1,1,1,1,1,1,1,1,1,1,1,52,0);
_NAMES(fam12h_MC2_CTL,"SRDE_HP","SRDE_TLB","SRDE_ALL","L2T_PAR","L2T_CECC","L2T_UECC","L2D_PAR","L2D_CECC","L2D_UECC",0,"VB_PAR","PDC_PAR",0);
_RANGE(fam12h_MC2_STATUS,16,4,4,8,13,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(fam12h_MC2_STATUS,"ErrorCode","ErrorCodeExt",0,"Syndrome",0,"UECC","CECC","Syndrome",0,"PCC","AddrV","MiscV","En","UC","OVER","VAL");
_RANGE(fam12h_MC2_ADDR,64,0);
_NAMES(fam12h_MC2_ADDR,"ADDR");
_RANGE(fam12h_MC2_MISC,64,0);
_NAMES(fam12h_MC2_MISC,0);
_RANGE(fam12h_MC3_CTL,1,1,62,0);
_NAMES(fam12h_MC3_CTL,"SRDE_L","SRDE_S",0);
_RANGE(fam12h_MC3_STATUS,16,4,4,8,13,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(fam12h_MC3_STATUS,"ErrorCode","ErrorCodeExt",0,"Syndrome",0,"UECC","CECC","Syndrome",0,"PCC","AddrV","MiscV","En","UC","OVER","VAL");
_RANGE(fam12h_MC3_ADDR,64,0);
_NAMES(fam12h_MC3_ADDR,"ADDR");
_RANGE(fam12h_MC3_MISC,64,0);
_NAMES(fam12h_MC3_MISC,0);
_RANGE(fam12h_MC4_CTL,5,1,2,1,1,1,1,1,1,2,1,1,7,1,38,0);
_NAMES(fam12h_MC4_CTL,0,"SyncFloodEn",0,"MstrAbrtEn","TgtAbrtEn",0,"AtomicRMWEn","WDTRptEn","DevErrEn",0,"ProtEn","DataEn",0,"McaUsPwDatErrEn",0);
_RANGE(fam12h_MC4_STATUS,16,5,11,1,1,1,1,1,20,1,1,1,1,1,1,1,0);
_NAMES(fam12h_MC4_STATUS,"ErrorCode","ErrorCodeExt",0,"ErrCpu0","ErrCpu1","ErrCpu2","ErrCpu3","BusErr",0,"PCC","AddrV",0,"En","UC","Over","Val");
_RANGE(fam12h_MC4_ADDR,32,32,0);
_NAMES(fam12h_MC4_ADDR,"McaNbAddrLow","McaNbAddrHigh");
_RANGE(fam12h_MC4_MISC0,64,0);
_NAMES(fam12h_MC4_MISC0,0);
_RANGE(fam12h_MC5_CTL,1,63,0);
_NAMES(fam12h_MC5_CTL,"CPUWDT",0);
_RANGE(fam12h_MC5_STATUS,16,4,4,8,13,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(fam12h_MC5_STATUS,"ErrorCode","ErrorCodeExt",0,"Syndrome",0,"UECC","CECC","Syndrome",0,"PCC","AddrV","MiscV","En","UC","OVER","VAL");
_RANGE(fam12h_MC5_ADDR,64,0);
_NAMES(fam12h_MC5_ADDR,"ADDR");
_RANGE(fam12h_MC5_MISC,12,52,0);
_NAMES(fam12h_MC5_MISC,"State",0);
_RANGE(fam12h_EFER,1,7,1,1,1,1,1,1,1,49,0);
_NAMES(fam12h_EFER,"SYSCALL",0,"LME",0,"LMA","NXE","SVME","LMSLE","FFXSE",0);
_RANGE(fam12h_STAR,32,16,16,0);
_NAMES(fam12h_STAR,"Target","SysCallSel","SysRetSel");
_RANGE(fam12h_STAR64,64,0);
_NAMES(fam12h_STAR64,"LSTAR");
_RANGE(fam12h_STARCOMPAT,64,0);
_NAMES(fam12h_STARCOMPAT,"CSTAR");
_RANGE(fam12h_SYSCALL_FLAG_MASK,32,32,0);
_NAMES(fam12h_SYSCALL_FLAG_MASK,"MASK",0);
_RANGE(fam12h_FS_BASE,64,0);
_NAMES(fam12h_FS_BASE,"FS_BASE");
_RANGE(fam12h_GS_BASE,64,0);
_NAMES(fam12h_GS_BASE,"GS_BASE");
_RANGE(fam12h_KernelGSbase,64,0);
_NAMES(fam12h_KernelGSbase,"KernelGSBase");
_RANGE(fam12h_TSC_AUX,32,32,0);
_NAMES(fam12h_TSC_AUX,"TscAux",0);
_RANGE(fam12h_PERF_CTL0,8,8,1,1,1,1,1,1,1,1,8,4,4,1,1,22,0);
_NAMES(fam12h_PERF_CTL0,"EventSelect","UnitMask","User","OS","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"GuestOnly","HostOnly",0);
_RANGE(fam12h_PERF_CTL1,8,8,1,1,1,1,1,1,1,1,8,4,4,1,1,22,0);
_NAMES(fam12h_PERF_CTL1,"EventSelect","UnitMask","User","OS","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"GuestOnly","HostOnly",0);
_RANGE(fam12h_PERF_CTL2,8,8,1,1,1,1,1,1,1,1,8,4,4,1,1,22,0);
_NAMES(fam12h_PERF_CTL2,"EventSelect","UnitMask","User","OS","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"GuestOnly","HostOnly",0);
_RANGE(fam12h_PERF_CTL3,8,8,1,1,1,1,1,1,1,1,8,4,4,1,1,22,0);
_NAMES(fam12h_PERF_CTL3,"EventSelect","UnitMask","User","OS","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"GuestOnly","HostOnly",0);
_RANGE(fam12h_PERF_CTR0,48,16,0);
_NAMES(fam12h_PERF_CTR0,"CTR",0);
_RANGE(fam12h_PERF_CTR1,48,16,0);
_NAMES(fam12h_PERF_CTR1,"CTR",0);
_RANGE(fam12h_PERF_CTR2,48,16,0);
_NAMES(fam12h_PERF_CTR2,"CTR",0);
_RANGE(fam12h_PERF_CTR3,48,16,0);
_NAMES(fam12h_PERF_CTR3,"CTR",0);
_RANGE(fam12h_SYS_CFG,8,1,1,1,5,1,1,1,1,1,1,1,41,0);
_NAMES(fam12h_SYS_CFG,0,"SetDirtyEnE","SetDirtyEnS","SetDirtyEnO",0,"ChxToDirtyDis","SysUcLockEn","MtrrFixDramEn","MtrrFixDramModeEn","MtrrVarDramEn","MtrrTom2En","Tom2ForceMemTypeWB",0);
_RANGE(fam12h_HWCR,1,1,1,1,1,3,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,37,0);
_NAMES(fam12h_HWCR,"SmmLock","SlowFence",0,"TlbCacheDis","INVD_WBINVD",0,"IgnneEm","MonMwaitDis","MonMwaitUserEn",0,"SmiSpCycDis","RsmSpCycDis","SseDis",0,"Wrap32Dis","McStatusWrEn",0,"IoCfgGpFault","MisAlignSseDis",0,"ForceUsRdWrSzPrb","TscFreqSel","CpbDis","EffFreqCntMwait",0);
_RANGE(fam12h_IORR_BASE0,3,1,1,7,28,24,0);
_NAMES(fam12h_IORR_BASE0,0,"WrMem","RdMem",0,"PhyBase",0);
_RANGE(fam12h_IORR_MASK0,11,1,28,24,0);
_NAMES(fam12h_IORR_MASK0,0,"Valid","PhyMask",0);
_RANGE(fam12h_IORR_BASE1,3,1,1,7,28,24,0);
_NAMES(fam12h_IORR_BASE1,0,"WrMem","RdMem",0,"PhyBase",0);
_RANGE(fam12h_IORR_MASK1,11,1,28,24,0);
_NAMES(fam12h_IORR_MASK1,0,"Valid","PhyMask",0);
_RANGE(fam12h_TOP_MEM,23,17,24,0);
_NAMES(fam12h_TOP_MEM,0,"TOM",0);
_RANGE(fam12h_TOM2,23,17,24,0);
_NAMES(fam12h_TOM2,0,"TOM2",0);
_RANGE(fam12h_NB_CFG,45,1,1,11,1,5,0);
_NAMES(fam12h_NB_CFG,0,"DisUsSysMgtReqToNcHt","EnableCf8ExtCfg",0,"EnConvertToNonIsoc",0);
_RANGE(fam12h_MCEredirection,8,1,1,54,0);
_NAMES(fam12h_MCEredirection,"RedirVector","RedirVecEn","RedirSmiEn",0);
_RANGE(fam12h_ProcessorNameString0,64,0);
_NAMES(fam12h_ProcessorNameString0,"CpuNameString");
_RANGE(fam12h_ProcessorNameString1,64,0);
_NAMES(fam12h_ProcessorNameString1,"CpuNameString");
_RANGE(fam12h_ProcessorNameString2,64,0);
_NAMES(fam12h_ProcessorNameString2,"CpuNameString");
_RANGE(fam12h_ProcessorNameString3,64,0);
_NAMES(fam12h_ProcessorNameString3,"CpuNameString");
_RANGE(fam12h_ProcessorNameString4,64,0);
_NAMES(fam12h_ProcessorNameString4,"CpuNameString");
_RANGE(fam12h_ProcessorNameString5,64,0);
_NAMES(fam12h_ProcessorNameString5,"CpuNameString");
_RANGE(fam12h_MC0_CTL_MASK,1,1,1,1,1,1,1,57,0);
_NAMES(fam12h_MC0_CTL_MASK,"ECCI","ECCM","DECC","DMTP","DSTP","L1TP","L2TP",0);
_RANGE(fam12h_MC1_CTL_MASK,1,1,1,1,1,1,1,2,1,54,0);
_NAMES(fam12h_MC1_CTL_MASK,"ECCI","ECCM","IDP","IMTP","ISTP","L1TP","L2TP",0,"RDDE",0);
_RANGE(fam12h_MC2_CTL_MASK,1,1,1,1,1,1,1,1,1,1,1,1,52,0);
_NAMES(fam12h_MC2_CTL_MASK,"SRDE_HP","SRDE_TLB","SRDE_ALL","L2T_PAR","L2T_CECC","L2T_UECC","L2D_PAR","L2D_CECC","L2D_UECC",0,"VB_PAR","PDC_PAR",0);
_RANGE(fam12h_MC3_CTL_MASK,1,1,62,0);
_NAMES(fam12h_MC3_CTL_MASK,"SRDE_L","SRDE_S",0);
_RANGE(fam12h_MC4_CTL_MASK,5,1,2,1,1,1,1,1,1,2,1,1,7,1,38,0);
_NAMES(fam12h_MC4_CTL_MASK,0,"SyncFloodEn",0,"MstrAbrtEn","TgtAbrtEn",0,"AtomicRMWEn","WDTRptEn","DevErrEn",0,"ProtEn","DataEn",0,"McaUsPwDatErrEn",0);
_RANGE(fam12h_MC5_CTL_MASK,1,63,0);
_NAMES(fam12h_MC5_CTL_MASK,"CPUWDT",0);
_RANGE(fam12h_SMI_ON_IO_TRAP_0,32,24,5,1,1,1,0);
_NAMES(fam12h_SMI_ON_IO_TRAP_0,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam12h_SMI_ON_IO_TRAP_1,32,24,5,1,1,1,0);
_NAMES(fam12h_SMI_ON_IO_TRAP_1,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam12h_SMI_ON_IO_TRAP_2,32,24,5,1,1,1,0);
_NAMES(fam12h_SMI_ON_IO_TRAP_2,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam12h_SMI_ON_IO_TRAP_3,32,24,5,1,1,1,0);
_NAMES(fam12h_SMI_ON_IO_TRAP_3,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam12h_SMI_ON_IO_TRAP_CTL_STS,1,1,1,1,1,1,1,1,7,1,48,0);
_NAMES(fam12h_SMI_ON_IO_TRAP_CTL_STS,0,"SmiEn_0",0,"SmiEn_1",0,"SmiEn_2",0,"SmiEn_3",0,"IoTrapEn",0);
_RANGE(fam12h_SmiTriggerIoCycle,16,8,1,1,1,37,0);
_NAMES(fam12h_SmiTriggerIoCycle,"IoPortAddress","IoData",0,"IoCycleEn","IoRd",0);
_RANGE(fam12h_MmioConfigBase,1,1,4,14,20,24,0);
_NAMES(fam12h_MmioConfigBase,"Enable",0,"SegBusRange",0,"MmiocCfgBaseAddr",0);
_RANGE(fam12h_BistResults,32,32,0);
_NAMES(fam12h_BistResults,"BistResults",0);
_RANGE(fam12h_PstateCurrentLimit,3,1,3,57,0);
_NAMES(fam12h_PstateCurrentLimit,"CurPstateLimit",0,"PstateMaxVal",0);
_RANGE(fam12h_PstateControl,3,61,0);
_NAMES(fam12h_PstateControl,"PstateCmd",0);
_RANGE(fam12h_PstateStatus,3,61,0);
_NAMES(fam12h_PstateStatus,"CurPstate",0);
_RANGE(fam12h_Pstate0,4,5,7,16,8,2,21,1,0);
_NAMES(fam12h_Pstate0,"CpuDid","CpuFid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam12h_Pstate1,4,5,7,16,8,2,21,1,0);
_NAMES(fam12h_Pstate1,"CpuDid","CpuFid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam12h_Pstate2,4,5,7,16,8,2,21,1,0);
_NAMES(fam12h_Pstate2,"CpuDid","CpuFid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam12h_Pstate3,4,5,7,16,8,2,21,1,0);
_NAMES(fam12h_Pstate3,"CpuDid","CpuFid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam12h_Pstate4,4,5,7,16,8,2,21,1,0);
_NAMES(fam12h_Pstate4,"CpuDid","CpuFid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam12h_Pstate5,4,5,7,16,8,2,21,1,0);
_NAMES(fam12h_Pstate5,"CpuDid","CpuFid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam12h_Pstate6,4,5,7,16,8,2,21,1,0);
_NAMES(fam12h_Pstate6,"CpuDid","CpuFid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam12h_Pstate7,4,5,7,16,8,2,21,1,0);
_NAMES(fam12h_Pstate7,"CpuDid","CpuFid","CpuVid",0,"IddValue","IddDiv",0,"PstateEn");
_RANGE(fam12h_COFVIDcontrol,4,5,7,3,1,44,0);
_NAMES(fam12h_COFVIDcontrol,"CpuDid","CpuFid","CpuVid","PstateId","IgnorVidFidDid",0);
_RANGE(fam12h_COFVIDstatus,4,5,7,3,1,1,4,7,3,7,7,6,1,3,5,0);
_NAMES(fam12h_COFVIDstatus,"CurCpuDid","CurCpuFid","CurCpuVid","CurPstate",0,"PstateInProgress",0,"CurNbVid","StartupPstate","MaxVid","MinVid","MainPllOpFreqIdMax",0,"CurPstateLimit",0);
_RANGE(fam12h_CstateAddress,16,48,0);
_NAMES(fam12h_CstateAddress,"CstateAddr",0);
_RANGE(fam12h_CpuWdTmrCfg,1,2,4,57,0);
_NAMES(fam12h_CpuWdTmrCfg,"CpuWdtEn","CpuWdtTimeBase","CpuWdtCountSel",0);
_RANGE(fam12h_SMM_BASE,32,32,0);
_NAMES(fam12h_SMM_BASE,"SMM_BASE",0);
_RANGE(fam12h_SMMAddr,17,23,24,0);
_NAMES(fam12h_SMMAddr,0,"TSegBase",0);
_RANGE(fam12h_SMMMask,1,1,1,1,1,1,2,3,1,3,2,23,24,0);
_NAMES(fam12h_SMMMask,"AValid","TValid","AClose","TClose","AMTypeIoWc","TMTypeIoWc",0,"AMTypeDram",0,"TMTypeDram",0,"TSegMask",0);
_RANGE(fam12h_VM_CR,1,1,1,1,1,59,0);
_NAMES(fam12h_VM_CR,"dpd","r_init","dis_a20m","Lock","Svme_Disable",0);
_RANGE(fam12h_IGNNE,1,63,0);
_NAMES(fam12h_IGNNE,"IGNNE",0);
_RANGE(fam12h_VM_HSAVE_PA,12,28,24,0);
_NAMES(fam12h_VM_HSAVE_PA,0,"VM_HSAVE_PA",0);
_RANGE(fam12h_SMIstatus,4,4,1,7,1,1,46,0);
_NAMES(fam12h_SMIstatus,"IoTrapSts",0,"MceRedirSts",0,"SmiSrcLvtLcy","SmiSrcLvtExt",0);
_RANGE(fam12h_OSVW_ID_Length,16,48,0);
_NAMES(fam12h_OSVW_ID_Length,"OSVW_ID_Length",0);
_RANGE(fam12h_OsvwStatus,64,0);
_NAMES(fam12h_OsvwStatus,"OsvwStatusBits");
_RANGE(fam12h_CPUIDFeatures,32,32,0);
_NAMES(fam12h_CPUIDFeatures,"FeaturesEdx","FeaturesEcx");
_RANGE(fam12h_CPUIDExtFeatures,32,32,0);
_NAMES(fam12h_CPUIDExtFeatures,"ExtFeaturesEdx","ExtFeaturesEcx");
_RANGE(fam12h_LS_CFG,28,1,35,0);
_NAMES(fam12h_LS_CFG,0,"DIS_SS",0);
_RANGE(fam12h_IC_CFG,9,1,54,0);
_NAMES(fam12h_IC_CFG,0,"DIS_SPEC_TLB_RLD",0);
_RANGE(fam12h_DC_CFG,4,1,3,1,4,1,50,0);
_NAMES(fam12h_DC_CFG,0,"DIS_SPEC_TLB_RLD",0,"DIS_CLR_WBTOL2_SMC_HIT",0,"DIS_HW_PF",0);
_RANGE(fam12h_DE_CFG,23,1,13,0);
_NAMES(fam12h_DE_CFG,0,"ClflushSerialize",0);
_RANGE(fam12h_BU_CFG2,35,1,14,1,5,1,2,5,0);
_NAMES(fam12h_BU_CFG2,0,"IcDisSpecTlbWr",0,"RdMmExtCfgDwDis",0,"L2ClkGatingEn","L2HystCnt",0);
_RANGE(fam12h_IbsFetchCtl,16,16,16,1,1,1,1,1,2,1,1,1,6,0);
_NAMES(fam12h_IbsFetchCtl,"IbsFetchMaxCnt","IbsFetchCnt","IbsFetchLat","IbsFetchEn","IbsFetchVal","IbsFetchComp","IbsIcMiss","IbsPhyAddrValid","IbsL1TlbPgSz","IbsL1TlbMiss","IbsL2TlbMiss","IbsRandEn",0);
_RANGE(fam12h_IbsFetchLinAd,64,0);
_NAMES(fam12h_IbsFetchLinAd,"IbsFetchLinAd");
_RANGE(fam12h_IbsFetchPhysAd,64,0);
_NAMES(fam12h_IbsFetchPhysAd,"IbsFetchPhysAd");
_RANGE(fam12h_IbsOpCtl,16,1,1,1,1,7,5,20,7,5,0);
_NAMES(fam12h_IbsOpCtl,"IbsOpMaxCnt",0,"IbsOpEn","IbsOpVal","IbsOpCntCtl","IbsOpMaxCntExt",0,"IbsOpCurCnt","IbsOpCurCntExt",0);
_RANGE(fam12h_IbsOpRip,64,0);
_NAMES(fam12h_IbsOpRip,"IbsOpRip");
_RANGE(fam12h_IbsOpData,16,16,1,1,1,1,1,1,1,25,0);
_NAMES(fam12h_IbsOpData,"IbsCompToRetCtr","IbsTagToRetCtr","IbsOpBrnResync","IbsOpMispReturn","IbsOpReturn","IbsOpBrnTaken","IbsOpBrnMisp","IbsOpBrnRet","IbsRipInvalid",0);
_RANGE(fam12h_IbsOpData2,3,61,0);
_NAMES(fam12h_IbsOpData2,"NbIbsReqSrc",0);
_RANGE(fam12h_IbsOpData3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,12,16,16,0);
_NAMES(fam12h_IbsOpData3,"IbsLdOp","IbsStOp","IbsDcL1tlbMiss","IbsDcL2tlbMiss","IbsDcL1tlbHit2M","IbsDcL1tlbHit1G","IbsDcL2tlbHit2M","IbsDcMiss","IbsDcMisAcc","IbsDcLdBnkCon","IbsDcStBnkCon","IbsDcStToLdFwd","IbsDcStToLdCan","IbsDcWcMemAcc","IbsDcUcMemAcc","IbsDcLockedOp","IbsDcMabHit","IbsDcLinAddrValid","IbsDcPhyAddrValid","IbsDcL2tlbHit1G",0,"IbsDcMissLat",0);
_RANGE(fam12h_IbsDcLinAd,64,0);
_NAMES(fam12h_IbsDcLinAd,"IbsDcLinAd");
_RANGE(fam12h_IbsDcPhysAd,64,0);
_NAMES(fam12h_IbsDcPhysAd,"IbsDcPhysAd");
_RANGE(fam12h_IbsControl,4,4,1,55,0);
_NAMES(fam12h_IbsControl,"LvtOffset",0,"LvtOffsetVal",0);
_RANGE(fam12h_IbsBranchTargetAddress,64,0);
_NAMES(fam12h_IbsBranchTargetAddress,"IbsBrTarget");

struct reg_spec fam12h_spec [] = {
	_SPEC(0x0000, LSMCAaddr, "load-store MCA address", fam12h_),
	_SPEC(0x0001, LSMCAstatus, "load-store MCE status", fam12h_),
	_SPEC(0x0010, TSC, "time-stamp counter", fam12h_),
	_SPEC(0x001b, APIC_BASE, "APIC base address", fam12h_),
	_SPEC(0x002a, EBL_CR_POWERON, "cluster ID", fam12h_),
	_SPEC(0x008b, PATCH_LEVEL, "microcode patch level", fam12h_),
	_SPEC(0x00e7, MPERF, "max performance frequency clock count", fam12h_),
	_SPEC(0x00e8, APERF, "actual performance frequency clock count", fam12h_),
	_SPEC(0x00fe, MTRRcap, "MTRR capabilities", fam12h_),
	_SPEC(0x0174, SYSENTER_CS, "SYSENTER/SYSEXIT code segment selector", fam12h_),
	_SPEC(0x0175, SYSENTER_ESP, "SYSENTER/SYSEXIT stack pointer", fam12h_),
	_SPEC(0x0176, SYSENTER_EIP, "SYSENTER/SYSEXIT instruction pointer", fam12h_),
	_SPEC(0x0179, MCG_CAP, "global MC capabilities", fam12h_),
	_SPEC(0x017a, MCG_STAT, "global MC status", fam12h_),
	_SPEC(0x017b, MCG_CTL, "global MC control", fam12h_),
	_SPEC(0x01d9, DBG_CTL_MSR, "debug control", fam12h_),
	_SPEC(0x01db, BR_FROM, "last branch from IP", fam12h_),
	_SPEC(0x01dc, BR_TO, "last branch to IP", fam12h_),
	_SPEC(0x01dd, LastExceptionFromIP, "last exception from IP", fam12h_),
	_SPEC(0x01de, LastExceptionToIP, "last exception to IP", fam12h_),
	_SPEC(0x0200, MTRRphysBase0, "base of variable-size MTRR (0)", fam12h_),
	_SPEC(0x0201, MTRRphysMask0, "mask of variable-size MTRR (0)", fam12h_),
	_SPEC(0x0202, MTRRphysBase1, "base of variable-size MTRR (1)", fam12h_),
	_SPEC(0x0203, MTRRphysMask1, "mask of variable-size MTRR (1)", fam12h_),
	_SPEC(0x0204, MTRRphysBase2, "base of variable-size MTRR (2)", fam12h_),
	_SPEC(0x0205, MTRRphysMask2, "mask of variable-size MTRR (2)", fam12h_),
	_SPEC(0x0206, MTRRphysBase3, "base of variable-size MTRR (3)", fam12h_),
	_SPEC(0x0207, MTRRphysMask3, "mask of variable-size MTRR (3)", fam12h_),
	_SPEC(0x0208, MTRRphysBase4, "base of variable-size MTRR (4)", fam12h_),
	_SPEC(0x0209, MTRRphysMask4, "mask of variable-size MTRR (4)", fam12h_),
	_SPEC(0x020a, MTRRphysBase5, "base of variable-size MTRR (5)", fam12h_),
	_SPEC(0x020b, MTRRphysMask5, "mask of variable-size MTRR (5)", fam12h_),
	_SPEC(0x020c, MTRRphysBase6, "base of variable-size MTRR (6)", fam12h_),
	_SPEC(0x020d, MTRRphysMask6, "mask of variable-size MTRR (6)", fam12h_),
	_SPEC(0x020e, MTRRphysBase7, "base of variable-size MTRR (7)", fam12h_),
	_SPEC(0x020f, MTRRphysMask7, "mask of variable-size MTRR (7)", fam12h_),
	_SPEC(0x0250, MTRRfix64K_00000, "fixed range MTRR", fam12h_),
	_SPEC(0x0258, MTRRfix16K_80000, "fixed range MTRR", fam12h_),
	_SPEC(0x0259, MTRRfix16K_A0000, "fixed range MTRR", fam12h_),
	_SPEC(0x0268, MTRRfix4K_C0000, "fixed range MTRR", fam12h_),
	_SPEC(0x0269, MTRRfix4K_C8000, "fixed range MTRR", fam12h_),
	_SPEC(0x026a, MTRRfix4K_D0000, "fixed range MTRR", fam12h_),
	_SPEC(0x026b, MTRRfix4K_D8000, "fixed range MTRR", fam12h_),
	_SPEC(0x026c, MTRRfix4K_E0000, "fixed range MTRR", fam12h_),
	_SPEC(0x026d, MTRRfix4K_E8000, "fixed range MTRR", fam12h_),
	_SPEC(0x026e, MTRRfix4K_F0000, "fixed range MTRR", fam12h_),
	_SPEC(0x026f, MTRRfix4K_F8000, "fixed range MTRR", fam12h_),
	_SPEC(0x0277, PAT, "page attribute table", fam12h_),
	_SPEC(0x02ff, MTRRdefType, "MTRR default memory type", fam12h_),
	_SPEC(0x0400, MC0_CTL, "data cache MC control", fam12h_),
	_SPEC(0x0401, MC0_STATUS, "data cache MC status", fam12h_),
	_SPEC(0x0402, MC0_ADDR, "data cache MC address", fam12h_),
	_SPEC(0x0403, MC0_MISC, "data cache MC miscellaneous", fam12h_),
	_SPEC(0x0404, MC1_CTL, "instruction cache MC control", fam12h_),
	_SPEC(0x0405, MC1_STATUS, "instruction cache MC status", fam12h_),
	_SPEC(0x0406, MC1_ADDR, "instruction cache MC address", fam12h_),
	_SPEC(0x0407, MC1_MISC, "instruction cache MC miscellaneous", fam12h_),
	_SPEC(0x0408, MC2_CTL, "BU MC control", fam12h_),
	_SPEC(0x0409, MC2_STATUS, "BU MC status", fam12h_),
	_SPEC(0x040a, MC2_ADDR, "BU MC address register", fam12h_),
	_SPEC(0x040b, MC2_MISC, "BU MC miscellaneous", fam12h_),
	_SPEC(0x040c, MC3_CTL, "LS MC control", fam12h_),
	_SPEC(0x040d, MC3_STATUS, "LS MC status", fam12h_),
	_SPEC(0x040e, MC3_ADDR, "LS MC address", fam12h_),
	_SPEC(0x040f, MC3_MISC, "LS MC miscellaneous", fam12h_),
	_SPEC(0x0410, MC4_CTL, "NB MC control", fam12h_),
	_SPEC(0x0411, MC4_STATUS, "NB MC status", fam12h_),
	_SPEC(0x0412, MC4_ADDR, "NB MC address", fam12h_),
	_SPEC(0x0413, MC4_MISC0, "reserved (NB MC misc)", fam12h_),
	_SPEC(0x0414, MC5_CTL, "FR MC control", fam12h_),
	_SPEC(0x0415, MC5_STATUS, "FR MC status", fam12h_),
	_SPEC(0x0416, MC5_ADDR, "FR MC address", fam12h_),
	_SPEC(0x0417, MC5_MISC, "FR MC miscellaneous", fam12h_),
	_SPEC(0xc0000080, EFER, "extended feature enable", fam12h_),
	_SPEC(0xc0000081, STAR, "SYSCALL target address", fam12h_),
	_SPEC(0xc0000082, STAR64, "long mode SYSCALL target address", fam12h_),
	_SPEC(0xc0000083, STARCOMPAT, "compat mode SYSCALL target address", fam12h_),
	_SPEC(0xc0000084, SYSCALL_FLAG_MASK, "SYSCALL flag mask", fam12h_),
	_SPEC(0xc0000100, FS_BASE, "FS base", fam12h_),
	_SPEC(0xc0000101, GS_BASE, "GS base", fam12h_),
	_SPEC(0xc0000102, KernelGSbase, "kernel GS base", fam12h_),
	_SPEC(0xc0000103, TSC_AUX, "auxiliary time stamp counter data", fam12h_),
	_SPEC(0xc0010000, PERF_CTL0, "performance event select (0)", fam12h_),
	_SPEC(0xc0010001, PERF_CTL1, "performance event select (1)", fam12h_),
	_SPEC(0xc0010002, PERF_CTL2, "performance event select (2)", fam12h_),
	_SPEC(0xc0010003, PERF_CTL3, "performance event select (3)", fam12h_),
	_SPEC(0xc0010004, PERF_CTR0, "performance event counter (0)", fam12h_),
	_SPEC(0xc0010005, PERF_CTR1, "performance event counter (1)", fam12h_),
	_SPEC(0xc0010006, PERF_CTR2, "performance event counter (2)", fam12h_),
	_SPEC(0xc0010007, PERF_CTR3, "performance event counter (3)", fam12h_),
	_SPEC(0xc0010010, SYS_CFG, "system configuration", fam12h_),
	_SPEC(0xc0010015, HWCR, "hardware configuration", fam12h_),
	_SPEC(0xc0010016, IORR_BASE0, "base of variable I/O range (0)", fam12h_),
	_SPEC(0xc0010017, IORR_MASK0, "mask of variable I/O range (0)", fam12h_),
	_SPEC(0xc0010018, IORR_BASE1, "base of variable I/O range (1)", fam12h_),
	_SPEC(0xc0010019, IORR_MASK1, "mask of variable I/O range (1)", fam12h_),
	_SPEC(0xc001001a, TOP_MEM, "top of memory address", fam12h_),
	_SPEC(0xc001001d, TOM2, "second top of memory address", fam12h_),
	_SPEC(0xc001001f, NB_CFG, "northbridge configuration", fam12h_),
	_SPEC(0xc0010022, MCEredirection, "MCE redirection", fam12h_),
	_SPEC(0xc0010030, ProcessorNameString0, "processor name string (0)", fam12h_),
	_SPEC(0xc0010031, ProcessorNameString1, "processor name string (1)", fam12h_),
	_SPEC(0xc0010032, ProcessorNameString2, "processor name string (2)", fam12h_),
	_SPEC(0xc0010033, ProcessorNameString3, "processor name string (3)", fam12h_),
	_SPEC(0xc0010034, ProcessorNameString4, "processor name string (4)", fam12h_),
	_SPEC(0xc0010035, ProcessorNameString5, "processor name string (5)", fam12h_),
	_SPEC(0xc0010044, MC0_CTL_MASK, "data cache MC control mask", fam12h_),
	_SPEC(0xc0010045, MC1_CTL_MASK, "instruction cache MC control mask", fam12h_),
	_SPEC(0xc0010046, MC2_CTL_MASK, "BU MC control mask", fam12h_),
	_SPEC(0xc0010047, MC3_CTL_MASK, "LS MC control mask", fam12h_),
	_SPEC(0xc0010048, MC4_CTL_MASK, "NB MC control mask", fam12h_),
	_SPEC(0xc0010049, MC5_CTL_MASK, "FR MC control mask", fam12h_),
	_SPEC(0xc0010050, SMI_ON_IO_TRAP_0, "IO trap address (0)", fam12h_),
	_SPEC(0xc0010051, SMI_ON_IO_TRAP_1, "IO trap address (1)", fam12h_),
	_SPEC(0xc0010052, SMI_ON_IO_TRAP_2, "IO trap address (2)", fam12h_),
	_SPEC(0xc0010053, SMI_ON_IO_TRAP_3, "IO trap address (3)", fam12h_),
	_SPEC(0xc0010054, SMI_ON_IO_TRAP_CTL_STS, "IO trap control", fam12h_),
	_SPEC(0xc0010056, SmiTriggerIoCycle, "SMI trigger IO cycle", fam12h_),
	_SPEC(0xc0010058, MmioConfigBase, "MMIO configuration base address", fam12h_),
	_SPEC(0xc0010060, BistResults, "BIST results", fam12h_),
	_SPEC(0xc0010061, PstateCurrentLimit, "P-state current limit", fam12h_),
	_SPEC(0xc0010062, PstateControl, "P-state control", fam12h_),
	_SPEC(0xc0010063, PstateStatus, "P-state status", fam12h_),
	_SPEC(0xc0010064, Pstate0, "P-state 0", fam12h_),
	_SPEC(0xc0010065, Pstate1, "P-state 1", fam12h_),
	_SPEC(0xc0010066, Pstate2, "P-state 2", fam12h_),
	_SPEC(0xc0010067, Pstate3, "P-state 3", fam12h_),
	_SPEC(0xc0010068, Pstate4, "P-state 4", fam12h_),
	_SPEC(0xc0010069, Pstate5, "P-state 5", fam12h_),
	_SPEC(0xc001006a, Pstate6, "P-state 6", fam12h_),
	_SPEC(0xc001006b, Pstate7, "P-state 7", fam12h_),
	_SPEC(0xc0010070, COFVIDcontrol, "COFVID control", fam12h_),
	_SPEC(0xc0010071, COFVIDstatus, "COFVID status", fam12h_),
	_SPEC(0xc0010073, CstateAddress, "C-state address", fam12h_),
	_SPEC(0xc0010074, CpuWdTmrCfg, "CPU watchdog timer", fam12h_),
	_SPEC(0xc0010111, SMM_BASE, "SMM base address", fam12h_),
	_SPEC(0xc0010112, SMMAddr, "SMM TSeg base address", fam12h_),
	_SPEC(0xc0010113, SMMMask, "SMM Tseg mask", fam12h_),
	_SPEC(0xc0010114, VM_CR, "virtual machine control", fam12h_),
	_SPEC(0xc0010115, IGNNE, "IGNNE", fam12h_),
	_SPEC(0xc0010117, VM_HSAVE_PA, "virtual machine host save physical address", fam12h_),
	_SPEC(0xc001011a, SMIstatus, "local SMI status", fam12h_),
	_SPEC(0xc0010140, OSVW_ID_Length, "OS visible work-around", fam12h_),
	_SPEC(0xc0010141, OsvwStatus, "OS visible work-around status bits", fam12h_),
	_SPEC(0xc0011004, CPUIDFeatures, "CPUID features", fam12h_),
	_SPEC(0xc0011005, CPUIDExtFeatures, "extended CPUID features", fam12h_),
	_SPEC(0xc0011020, LS_CFG, "load store configuration", fam12h_),
	_SPEC(0xc0011021, IC_CFG, "instruction cache configuration", fam12h_),
	_SPEC(0xc0011022, DC_CFG, "data cache configuration", fam12h_),
	_SPEC(0xc0011029, DE_CFG, "decode configuration", fam12h_),
	_SPEC(0xc001102A, BU_CFG2, "bus unit configuration 2", fam12h_),
	_SPEC(0xc0011030, IbsFetchCtl, "IBS fetch control", fam12h_),
	_SPEC(0xc0011031, IbsFetchLinAd, "IBS fetch linear address", fam12h_),
	_SPEC(0xc0011032, IbsFetchPhysAd, "IBS fetch physical address", fam12h_),
	_SPEC(0xc0011033, IbsOpCtl, "IBS execution control", fam12h_),
	_SPEC(0xc0011034, IbsOpRip, "IBS Op logical address", fam12h_),
	_SPEC(0xc0011035, IbsOpData, "IBS Op data", fam12h_),
	_SPEC(0xc0011036, IbsOpData2, "IBS Op data 2", fam12h_),
	_SPEC(0xc0011037, IbsOpData3, "IBS Op data 3", fam12h_),
	_SPEC(0xc0011038, IbsDcLinAd, "IBS DC linear address", fam12h_),
	_SPEC(0xc0011039, IbsDcPhysAd, "IBS DC physical address", fam12h_),
	_SPEC(0xc001103a, IbsControl, "IBS control", fam12h_),
	_SPEC(0xc001103b, IbsBranchTargetAddress, "IBS branch target address", fam12h_),
	{0, NULL, NULL, NULL, NULL},
};

#endif /* fam12h_h */
